/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 01 - solution 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[]) {
  int n, r, c;

  /* Get program argument */
  if (argc!=2) {
    /* Use stdout and stderr for controlled output */
    fprintf (stderr, "Run as: <pgrm> integerValue\n");
    return (0);
  }
  /* Conversion function: from ASCII to Integer */
  n = atoi (argv[1]);

  /* Use for cycle to be more compact */
  for (r=0; r<=n+1; r++) {
    fprintf (stdout, "-");
  }
  fprintf (stdout, "\n");

  for (r=1; r<=n; r++) {
    fprintf (stdout, "|");
    for (c=1; c<=n; c++) {
      if ((r%2==1 && c%2==1) || (r%2==0 && c%2==0)) {
        fprintf (stdout, "#");
      } else {
        fprintf (stdout, " ");
      }
    }
    fprintf (stdout, "|\n");
  }

  for (r=0; r<=n+1; r++) {
    fprintf (stdout, "-");
  }
  fprintf (stdout, "\n");

  return 1;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
