/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 02 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[]) {
  int n, r, c, left, right;

  /* Get program argument */
  if (argc!=2) {
    /* Use stdout and stderr for controlled output */
    fprintf (stderr, "Run as: <pgrm> oddIntegerValue\n");
    return (EXIT_FAILURE);
  }

  /* Conversion function: from ASCII to Integer */
  n = atoi (argv[1]);
  if (n%2 == 0) {
    fprintf (stderr, "Input value has to be odd.\n");
    return (EXIT_FAILURE);
  }

  /* Explicit cast operation (int) ... redundant */
  left = right = (int) (n/2);
  for (r=0; r<n; r++) {
    for (c=0; c<n; c++) {
      if (c==left || c==right) {
        fprintf (stdout, "+");
      } else {
        fprintf (stdout, "-");
      }
    }
    if (r < ((int) (n/2))) {
      left--;
      right++;
    } else {
      left++;
      right--;
    }
    fprintf (stdout, "\n");
  }

  return EXIT_SUCCESS;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
