/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 04 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define DIM 10

int main(void) {
  int i, j, n;
  int array[DIM];

  /* read in the array */
  printf("Input array:\n");
  for (i=0; i<DIM;i++) {
    printf("array[%d] = ", i);
    scanf("%d", &array[i]);
  }

  /* computation */
  n = DIM;
  i = 0;
  while (i < n) {
    if (array[i] == 0) {
      /* left-shift all remaining elements by one position */
      for (j=i+1; j<n; j++) {
        array[j-1] = array[j];
      }
      /* decrease the array logic size */
      n = n - 1;
    } else {
      /* move right only when there is no shift */
      i = i + 1;
    }
  }

  /* print the resulting array */
  printf("Output array:\n");
  for (i=0; i<n; i++) {
    printf("array[%d] = %d\n", i, array[i]);
  }
  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
