/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 07 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define SIZE 10

int main(void) {
  int i, val, flag;
  int classes[SIZE];

  /* init array: zero frequency */
  for (i=0; i<SIZE; i++) {
    classes[i] = 0;
  }

  /* input phase: read numbers and collect statistics */
  printf("Input sequence:\n");
  flag = 1;
  do {
    printf("Value = ");
    scanf("%d", &val);

    /* check the value for termination */
    if (val<0 || val>=SIZE*SIZE) {
      flag = 0;
    } else {
      /* increase the class frequency */
      classes[val/SIZE]++;
    }
  } while (flag == 1);

  /* output phase */
  flag = 1;
  while (flag == 1) {
    flag = 0;
    for (i=0; i<SIZE; i++) {
      if (classes[i] > 0) {
        printf("#");
        classes[i]--;
        flag = 1;
      } else {
        printf(" ");
      }
    }
    printf("\n");
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
