/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 08 - solution 3
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>

int main(int argc, char *argv[]) {
  int occurrences[26], i, flag;

  /* check parameters */
  if (argc != 3) {
    printf("Parameter error.\n");
    printf("Run program as: %s <string1> <string2>\n", argv[0]);
    return 1;
  }

  /* check for anagrams */
  for (i=0; i<26; i++) {
    occurrences[i] = 0;
  }
  for (i=0; i<strlen(argv[1]); i++) {
    occurrences[tolower(argv[1][i]) - 'a']++;
  }
  for (i=0; i<strlen(argv[2]); i++) {
    occurrences[tolower(argv[2][i]) - 'a']--;
  }
  flag = 1;
  for (i=0; i<26 && flag; i++) {
    if (occurrences[i] != 0) {
      flag = 0;
    }
  }

  /* output result */
  printf("The two words are%s anagrams.\n", flag ? "" : " NOT");

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
