/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 11 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define R 3
#define C 4

int main(void) {
  int matrix[R][C];
  int r, c, i, j;
  char flag;

  /* read matrix; each element must be positive */
  for (r=0; r<R; r++) {
    for (c=0; c<C; c++) {
      do {
        printf("Element [%d][%d] = ", r+1, c+1);
        scanf("%d", &matrix[r][c]);
      } while (matrix[r][c]<=0);
    }
  }

  /* computation: for each matrix element ... */
  for (r=0; r<R; r++) {
    for (c=0; c<C; c++) {

      /* flag = 1 means that element (r, c) is a local minimum */
      flag = 1;

      /* ... check the 8 adiacent elements out ... */
      for (i=r-1; i<=r+1 && flag==1; i++) {
        for (j=c-1; j<=c+1 && flag==1; j++) { 
          if ((i!=r || j!=c) && i>=0 && i<R && j>=0 && j<C) {
            if (matrix[r][c] >= matrix[i][j]) {
              flag = 0;
            }
          }
        }
      }

      /* ... and print the result */
      if (flag == 1) {
        printf("Local Minimum (value=%d) ", matrix[r][c]);
        printf("at row=%d, column=%d.\n", r, c);
      }
    }
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
