/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 13 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define DIM 50

/* function prototypes */
int searchSubStr (char str1[], char str2[], int from);

/*
 *  main program
 */
int main (int argc, char *argv[]) {
  char str1[DIM+1], str2[DIM+1], str3[DIM+1];
  char strOut[DIM*DIM+1];
  int i, idx, from, to, endFlag;

  /* check parameters */
  if (argc != 4) {
    printf("Parameter error.\n");
    printf("Run program as: %s <string1> <string2> <string3>\n", argv[0]);
    return 1;
  }

  strcpy(str1, argv[1]);
  strcpy(str2, argv[2]);
  strcpy(str3, argv[3]);

  /* computation and output */
  endFlag = from = idx = 0;
  do {
    to = searchSubStr(str1, str2, from);
    if (to < 0) {
      to = strlen(str1);
      endFlag = 1;
    }
    for (i=from; i<to; i++) {
      strOut[idx] = str1[i];
      idx++;
    }
    if (endFlag == 0) {
      for (i=0; i<strlen(str3); i++) {
        strOut[idx] = str3[i];
        idx++;
      }
    }
    from = to+strlen(str2);
  } while (endFlag != 1);

  strOut[idx] = '\0';
  printf("%s\n", strOut);
  return 0;
}

/*
 *  search a sub-string
 */
int searchSubStr(char str1[], char str2[], int from) {
  int i, j, flag;
  
  i = from;
  while (i < strlen(str1)-strlen(str2)) {
    flag = j = 0;
    while (j<strlen(str2) && flag==0) {
      if (str1[i+j] != str2[j]) {
        flag = 1;
      }
      j++;
    }
    if (flag == 0) {
      return i;
    }
    i++;
  } 
  return -1;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
