/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 16 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <ctype.h>

#define ROW_LENGTH 20

int main(int argc, char *argv[]) {
  int i;
  char c, blank;
  FILE *fin, *fout;

  if (argc < 3) {
    printf("Error: missing parameter.\n");
    printf("Run as: %s <input_file> <output_file>.\n", argv[0]);
    return 1;
  }

  /* open the files */
  fin = fopen(argv[1], "r");
  if (fin == NULL) {
    printf("Error opening the input file.\n");
    return 1;
  }
  fout = fopen(argv[2], "w");
  if (fout == NULL) {
    printf("Error opening the output file.\n");
    return 1;
  }

  /* computation */
  i = 0;  
  blank = 0;
  while (fscanf(fin, "%c", &c) != EOF) {
    if (c != '\n') {
      if (c == ' ') {
        blank = 1;
      } else {
        if (blank) {
          c = toupper(c);
          blank = 0;
        }

        fprintf(fout, "%c", c);
        i++;
      
        if (i == ROW_LENGTH) {
          fprintf(fout, "\n");
          i = 0;
        }
      }
    }
  }
  if (i != 0) {
    fprintf(fout, "\n");
  }
  fclose(fin);
  fclose(fout);

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
