/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 05 - exercise 02 - solution 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

/* function prototypes */
int fibonacci_r (int n, int *known);

/*
 *  main program
 */
int main (void) {
  int *known, i, n;

  fprintf(stdout, "Input n: ");
  scanf("%d", &n);
  known = (int *) malloc ((n+1)*sizeof(int));
  if (known==NULL){
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  for (i=0; i<=n; i++) {
    known[i] = -1;
  }
  fprintf(stdout, "Fibonacci %d-th term = %d\n", n, fibonacci_r(n, known));
  free(known);

  return EXIT_SUCCESS;
}

/*
 *  computation of the n-th Fibonacci term, recursive function
 */
int fibonacci_r (int n, int *known) {
  if (known[n] < 0) {
    if (n==0 || n==1) {
      known[n] = n;
    } else {
      known[n] = fibonacci_r(n-1, known)+fibonacci_r(n-2, known);
    }
  }

  return known[n];
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
