/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 05 - exercise 03 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

/* function prototypes */
float power_r (float x, int n);

/*
 *  main program
 */
int main (void) {
  float x, y;
  int n;

  fprintf(stdout, "Base x: ");
  scanf("%f", &x);
  fprintf(stdout, "Exponent n (>= 0): ");
  scanf("%d", &n);

  y = power_r(x, n);
  fprintf(stdout, "Power (%.2f^%d) = %.3f\n", x, n, y);

  return EXIT_SUCCESS;
}

/*
 *  power computation, recursive function
 */
float power_r (float x, int n) {
  if (n <= 0) {
    return 1.0;
  }

  return x*power_r(x, n-1);
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
