/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 05 - exercise 04 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

#define N 10

/* function prototypes */
void array_r_ver1 (int [], int *, int *, int);
void array_r_ver2 (int *, int *, int *, int);

/*
 *  main program
 */
int main (void) {
  int v[N] = {1, 3, 5, 7, 9, 11, 8, 6, 4, 2};
  int min, max;

  min = INT_MAX;
  max = INT_MIN;
  fprintf(stdout, "Array: ");
  array_r_ver1 (v, &min, &max, 0);
  fprintf(stdout, "\n");
  fprintf(stdout, "Min = %d\n", min);
  fprintf(stdout, "Max = %d\n", max);

  min = INT_MAX;
  max = INT_MIN;
  fprintf(stdout, "Array: ");
  array_r_ver2 (&v[0], &min, &max, 0);
  fprintf(stdout, "\n");
  fprintf(stdout, "Min = %d\n", min);
  fprintf(stdout, "Max = %d\n", max);

  return EXIT_SUCCESS;
}

/*
 *  array visit using the [] notation
 */
void array_r_ver1 (int v[], int *min, int *max, int n) {
  if (n >= N) {
    return;
  }

  fprintf (stdout, "%d ", v[n]);

  if (v[n] < (*min)) {
    *min = v[n];
  }
  if (v[n] > (*max)) {
    *max = v[n];
  }
  array_r_ver1 (v, min, max, n+1);

  return;
}

/*
 *  array visit usin the pointer * notation
 */
void array_r_ver2 (int *v, int *min, int *max, int n) {
  if (n >= N) {
    return;
  }

  fprintf (stdout, "%d ", *v);

  if ((*v) < (*min)) {
    *min = *v;
  }
  if ((*v) > (*max)) {
    *max = *v;
  }
  array_r_ver2 (v+1, min, max, n+1);

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
