/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 06 - exercise 01 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

#define N 10

/* function prototypes */
int search_r (int [], int, int, int);
int search_i (int [], int, int, int);

/*
 *  main program
 */
int main (void) {
  int i, v[N], d, posr, posi;

  /* input data */
  fprintf(stdout, "Input sorted array (dim=%d):\n", N);
  for (i=0; i<N; i++) {
    fprintf(stdout, "v[%d] = ", i);
    scanf("%d", &v[i]);
  }
  fprintf(stdout, "Number to search = ");
  scanf("%d", &d);

  /* search and output result */
  posr = search_r(v, 0, N-1, d);
  posi = search_i(v, 0, N-1, d);
  if (posr>=0 && posi>=0) {
    fprintf(stdout, "Number %d found in position: rec=%d ite=%d.\n",
      d, posr, posi);
  } else {
    fprintf(stdout, "Number %d NOT found.\n", d);
  }

  return EXIT_SUCCESS;
}

/*
 *  binary search, recursive function
 */
int search_r (int v[], int left, int right, int d) {
  int c;

  if (left > right) {
    return -1;
  }

  c = (left+right)/2;
  if (d < v[c]) {
    return search_r(v, left, c-1, d);
  }
  if (d > v[c]) {
    return search_r(v, c+1, right, d);
  }

  /* value found */
  return c;
}

/*
 * binary search, iterative function
 */
int search_i (int v[], int left, int right, int d) {
  int i;

  while (left<=right) {
    i = (left+right)/2;
    if (d == v[i]) {
      return i;
    }
    if (d < v[i]) {
      right = i - 1;
    } else {
      left = i + 1;
    }
  }

  return -1;
}


/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
