/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 06 - exercise 07 - solution 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

#define MAX 10
#define NUM 256

/* function prototypes */
int stat (char *, int *);
void generate_r (int *, char *, int, int);

/*
 *  main program
 */
int main (void) {
  int length, frequency[NUM];
  char word[MAX], anagram[MAX];

  fprintf(stdout, "Input a word: ");
  scanf("%s", word);
  length = stat(word, frequency);
  anagram[length] = '\0';

  fprintf(stdout, "Anagrams:\n");
  generate_r(frequency, anagram, length, 0);
  return EXIT_SUCCESS;
}

/*
 *  compute the frequencies of the characters in a word
 *  return the length of the word
 */
int stat (char *s, int *f) {
  int i;

  for (i=0; i<NUM; i++) {
    f[i] = 0;
  }

  for(i=0; s[i]!='\0'; i++) {
    f[(int)s[i]]++;
  }

  return i;
}

/*
 *  add a char in position n of the anagram taking it from the pool 
 *  of available chars described by the frequency parameter
 */
void generate_r (int *frequency, char *anagram, int length, int n) {
  int c;

  if (n >= length) {
    fprintf(stdout, "  %s\n", anagram);
    return;
  }

  for (c=0; c<NUM; c++) {
    if (frequency[c] > 0) {  
      /* available char */
      anagram[n] = c;
      frequency[c]--;
      generate_r(frequency, anagram, length, n+1);
      frequency[c]++;
    }
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
