/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 07 - exercise 01 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

/* function prototypes */
void hanoi_r (int, int, int);

/*
 *  main program
 */
int main (void) {
  int n;

  fprintf(stdout, "Number of disks: ");
  scanf("%d", &n);
  hanoi_r(n, 0, 2);

  return EXIT_SUCCESS;
}

/*
 *  generate the hanoi moves, recursive function
 */
void hanoi_r (int n, int src, int dst) {
  int aux;

  if (n > 0) {
    aux = 3 - (src + dst);
    hanoi_r(n-1, src, aux);
    fprintf(stdout, "Disk %d from peg %c to peg %c\n", n, 'A'+src, 'A'+dst);
    hanoi_r(n-1, aux, dst);
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
