/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 09 - exercise 01 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "util.h"

#define MAX 82 /* 80 + '\n' + '\0' */

/* static function prototypes */
static char **file_read(char *filename, int *num_ptr);
static void file_write(char *filename, char **array, int num);

/*
 *  main program
 */
int main (int argc, char *argv[]) {
  char **array;
  int num;

  util_check_m(argc>=3, "missing parameter.");

  array = file_read(argv[1], &num);
  file_write(argv[2], array, num);
  util_array_dispose((void **)array, num, free);

  return EXIT_SUCCESS;
}

/*
 *  load the input file contents
 */
static char **file_read (char *filename, int *num_ptr) {
  char **array, line[MAX];
  int i, n=0;
  FILE *fp;

  fp = util_fopen(filename, "r");

  /* count the number of rows */
  while (fgets(line, MAX, fp) != NULL) {
    n++;
  }
  fclose(fp);

  /* store the file contents */
  array = (char **)util_malloc(n * sizeof(char *));
  fp = util_fopen(filename, "r");
  for (i=0; i<n; i++) {
    fgets(line, MAX, fp);
    array[i] = util_strdup(line);
  }
  fclose(fp);

  *num_ptr = n;
  return array;
}

/*
 *  write the output file 
 */
static void file_write (char *filename, char **array, int num) {
  FILE *fp;
  int i, j;

  fp = util_fopen(filename, "w");
  for (i=num-1; i>=0; i--) {
    for (j=strlen(array[i])-2; j>=0; j--) {
      fprintf(fp, "%c", array[i][j]);
    }
    fprintf(fp, "\n");
  }
  fclose(fp);
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
