/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 09 - exercise 08 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "util.h"
#include "item.h"
#include "sort.h"

#define DEBUG  1

/* static function prototypes */
static item_t *loadData(int *size_ptr);
static void printData(item_t *array, int num);

/*
 *  main program
 */
int main (void) {
  item_t *array;
  int num;

  /* load the data array */
  array = loadData(&num);

  /* sort the data array */
  sort_quick(array, num);

  /* print the resulting array */
  printData(array, num);

  util_array_dispose((void **)array, num, item_dispose);
  return EXIT_SUCCESS;
}

/*
 *  load the data from file
 */
static item_t *loadData(int *num_ptr) {
  char filename[51];
  item_t *array;
  int i, num=0;
  FILE *fp;

  fprintf(stdout, "Input the file name: ");
  scanf("%s", filename);

  fp = util_fopen(filename, "r");
  fscanf(fp, "%d", &num);
  array = (item_t *)util_malloc(num*sizeof(item_t));
  for (i=0; i<num; i++) {
    item_read(fp, (void **)&array[i]);
  }
  fclose(fp);

#if DEBUG
  /* debug print out */
  fprintf(stdout, "Number of data loaded: %d\n", num);
  printData(array, num);
  fprintf(stdout, "\n");
#endif

  *num_ptr = num;
  return array;
}

/* 
 *  print-out the sorted data array
 */
static void printData(item_t *array, int num) {
  int i;

  for (i=0; i<num; i++) {
    item_print(stdout, array[i]);
    fprintf(stdout, "\n");
  }
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
