/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 09 - exercise 09 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "util.h"
#include "stackPublic.h"

int main (int argc, char *argv[]) {
  long int result;
  int left, right, length, k=0;
  stack_t *sp=NULL;
  char *expr;

  util_check_m(argc>=2, "missing parameter.");
  expr = argv[1];
  length = strlen(expr);
  sp = stack_init(length);

  while (k < length) {
    if (isdigit(expr[k])) {
      sscanf(&expr[k], "%ld", &result);
      stack_push(sp, (void *)result);
      while (isdigit(expr[k])) {
        k++;
      }
    } else if (expr[k]=='+' || expr[k]=='*' || expr[k]=='-' || expr[k]=='/') {
      stack_pop(sp, (void **)&right);
      stack_pop(sp, (void **)&left);
      switch (expr[k]) {
        case '+': result = left+right; break;
        case '*': result = left*right; break;
        case '-': result = left-right; break;
        case '/': result = left/right; break;
      }
      stack_push(sp, (void *)result);
    } 
    k++;
  }

  stack_pop(sp, (void **)&result);
  fprintf(stdout, "Result = %ld\n", result);
  stack_dispose(sp, NULL);

  return EXIT_SUCCESS;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
